## org.h2.expression
Class Comparison

    java.lang.Object
      org.h2.expression.Expression
          org.h2.expression.Condition
              org.h2.expression.Comparison

    public class Comparison

extends Condition

Example comparison expressions are ID=1, NAME=NAME, NAME IS NULL.

Field Summary
`static int` `BIGGER` The comparison type meaning > as in ID>1.
`static int` `BIGGER_EQUAL` The comparison type meaning >= as in ID>=1.
`static int` `EQUAL` The comparison type meaning = as in ID=1.
`static int` `EQUAL_NULL_SAFE` The comparison type meaning ID IS 1 (ID IS NOT DISTINCT FROM 1).
`static int` `FALSE` This is a pseudo comparison type that is only used for index conditions.
`static int` `IN_LIST` This is a pseudo comparison type that is only used for index conditions.
`static int` `IN_QUERY` This is a pseudo comparison type that is only used for index conditions.
`static int` `IS_NOT_NULL` The comparison type meaning IS NOT NULL as in NAME IS NOT NULL.
`static int` `IS_NULL` The comparison type meaning IS NULL as in NAME IS NULL.
`static int` `NOT_EQUAL` The comparison type meaning <> as in ID<>1.
`static int` `NOT_EQUAL_NULL_SAFE` The comparison type meaning ID IS NOT 1 (ID IS DISTINCT FROM 1).
`static int` `NULL_SAFE` This is a flag meaning the comparison is null safe (meaning never returns NULL even if one operand is NULL).
`static int` `SMALLER` The comparison type meaning < as in ID<1.
`static int` `SMALLER_EQUAL` The comparison type meaning <= as in ID<=1.

Constructor Summary
`Comparison(Session session, int compareType, Expression left, Expression right)`

Method Summary
`void` `addFilterConditions(TableFilter filter, boolean outerJoin)` Add conditions to a table filter if they can be evaluated.
`void` `createIndexConditions(Session session, TableFilter filter)` Create index conditions if possible and attach them to the table filter.
`int` `getCost()` Estimate the cost to process the expression.
`Expression` `getExpression(boolean getLeft)` Get the left or the right sub-expression of this condition.
`Expression` `getNotIfPossible(Session session)` If it is possible, return the negated expression.
`java.lang.String` `getSQL()` Get the SQL statement of this expression.
`Value` `getValue(Session session)` Return the resulting value for the current row.
`boolean` `isEverything(ExpressionVisitor visitor)` Check if this expression and all sub-expressions can fulfill a criteria.
`void` `mapColumns(ColumnResolver resolver, int level)` Map the columns of the resolver to expression columns.
`Expression` `optimize(Session session)` Try to optimize the expression.
`void` `setEvaluatable(TableFilter tableFilter, boolean b)` Tell the expression columns whether the table filter can return values now.
`void` `updateAggregate(Session session)` Update an aggregate value.

Methods inherited from class org.h2.expression.Condition
`getDisplaySize, getPrecision, getScale, getType`

Methods inherited from class org.h2.expression.Expression
`getAlias, getBooleanValue, getColumnName, getExpressionColumns, getExpressionColumns, getExpressionColumns, getNonAliasExpression, getNullable, getSchemaName, getTableAlias, getTableName, isAutoIncrement, isConstant, isValueSet, isWildcard, toString`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### NULL_SAFE

    public static final int NULL_SAFE

  This is a flag meaning the comparison is null safe (meaning never returns NULL even if one operand is NULL). Only EQUAL and NOT_EQUAL are supported currently.

  See Also:
    Constant Field Values

### EQUAL

    public static final int EQUAL

  The comparison type meaning = as in ID=1.

  See Also:
    Constant Field Values

### EQUAL_NULL_SAFE

    public static final int EQUAL_NULL_SAFE

  The comparison type meaning ID IS 1 (ID IS NOT DISTINCT FROM 1).

  See Also:
    Constant Field Values

### BIGGER_EQUAL

    public static final int BIGGER_EQUAL

  The comparison type meaning >= as in ID>=1.

  See Also:
    Constant Field Values

### BIGGER

    public static final int BIGGER

  The comparison type meaning > as in ID>1.

  See Also:
    Constant Field Values

### SMALLER_EQUAL

    public static final int SMALLER_EQUAL

  The comparison type meaning <= as in ID<=1.

  See Also:
    Constant Field Values

### SMALLER

    public static final int SMALLER

  The comparison type meaning < as in ID<1.

  See Also:
    Constant Field Values

### NOT_EQUAL

    public static final int NOT_EQUAL

  The comparison type meaning <> as in ID<>1.

  See Also:
    Constant Field Values

### NOT_EQUAL_NULL_SAFE

    public static final int NOT_EQUAL_NULL_SAFE

  The comparison type meaning ID IS NOT 1 (ID IS DISTINCT FROM 1).

  See Also:
    Constant Field Values

### IS_NULL

    public static final int IS_NULL

  The comparison type meaning IS NULL as in NAME IS NULL.

  See Also:
    Constant Field Values

### IS_NOT_NULL

    public static final int IS_NOT_NULL

  The comparison type meaning IS NOT NULL as in NAME IS NOT NULL.

  See Also:
    Constant Field Values

### FALSE

    public static final int FALSE

  This is a pseudo comparison type that is only used for index conditions. It means the comparison will always yield FALSE. Example: 1=0.

  See Also:
    Constant Field Values

### IN_LIST

    public static final int IN_LIST

  This is a pseudo comparison type that is only used for index conditions. It means equals any value of a list. Example: IN(1, 2, 3).

  See Also:
    Constant Field Values

### IN_QUERY

    public static final int IN_QUERY

  This is a pseudo comparison type that is only used for index conditions. It means equals any value of a list. Example: IN(SELECT ...).

  See Also:
    Constant Field Values

Constructor Detail

### Comparison

    public Comparison(Session session,
                      int compareType,
                      Expression left,
                      Expression right)

Method Detail

### getSQL

    public java.lang.String getSQL()

  Description copied from class: `Expression`
  Get the SQL statement of this expression. This may not always be the original SQL statement, specially after optimization.

  Specified by:
    `getSQL` in class `Expression`
  Returns:
    the SQL statement

### optimize

    public Expression optimize(Session session)

  Description copied from class: `Expression`
  Try to optimize the expression.

  Specified by:
    `optimize` in class `Expression`
  Parameters:
    `session` - the session
  Returns:
    the optimized expression

### getValue

    public Value getValue(Session session)

  Description copied from class: `Expression`
  Return the resulting value for the current row.

  Specified by:
    `getValue` in class `Expression`
  Parameters:
    `session` - the session
  Returns:
    the result

### getNotIfPossible

    public Expression getNotIfPossible(Session session)

  Description copied from class: `Expression`
  If it is possible, return the negated expression. This is used to optimize NOT expressions: NOT ID>10 can be converted to ID<=10. Returns null if negating is not possible.

  Overrides:
    `getNotIfPossible` in class `Expression`
  Parameters:
    `session` - the session
  Returns:
    the negated expression, or null

### createIndexConditions

    public void createIndexConditions(Session session,
                                      TableFilter filter)

  Description copied from class: `Expression`
  Create index conditions if possible and attach them to the table filter.

  Overrides:
    `createIndexConditions` in class `Expression`
  Parameters:
    `session` - the session
    `filter` - the table filter

### setEvaluatable

    public void setEvaluatable(TableFilter tableFilter,
                               boolean b)

  Description copied from class: `Expression`
  Tell the expression columns whether the table filter can return values now. This is used when optimizing the query.

  Specified by:
    `setEvaluatable` in class `Expression`
  Parameters:
    `tableFilter` - the table filter
    `b` - true if the table filter can return value

### updateAggregate

    public void updateAggregate(Session session)

  Description copied from class: `Expression`
  Update an aggregate value. This method is called at statement execution time. It is usually called once for each row, but if the expression is used multiple times (for example in the column list, and as part of the HAVING expression) it is called multiple times - the row counter needs to be used to make sure the internal state is only updated once.

  Specified by:
    `updateAggregate` in class `Expression`
  Parameters:
    `session` - the session

### addFilterConditions

    public void addFilterConditions(TableFilter filter,
                                    boolean outerJoin)

  Description copied from class: `Expression`
  Add conditions to a table filter if they can be evaluated.

  Overrides:
    `addFilterConditions` in class `Expression`
  Parameters:
    `filter` - the table filter
    `outerJoin` - if the expression is part of an outer join

### mapColumns

    public void mapColumns(ColumnResolver resolver,
                           int level)

  Description copied from class: `Expression`
  Map the columns of the resolver to expression columns.

  Specified by:
    `mapColumns` in class `Expression`
  Parameters:
    `resolver` - the column resolver
    `level` - the subquery nesting level

### isEverything

    public boolean isEverything(ExpressionVisitor visitor)

  Description copied from class: `Expression`
  Check if this expression and all sub-expressions can fulfill a criteria. If any part returns false, the result is false.

  Specified by:
    `isEverything` in class `Expression`
  Parameters:
    `visitor` - the visitor
  Returns:
    if the criteria can be fulfilled

### getCost

    public int getCost()

  Description copied from class: `Expression`
  Estimate the cost to process the expression. Used when optimizing the query, to calculate the query plan with the lowest estimated cost.

  Specified by:
    `getCost` in class `Expression`
  Returns:
    the estimated cost

### getExpression

    public Expression getExpression(boolean getLeft)

  Get the left or the right sub-expression of this condition.

  Parameters:
    `getLeft` - true to get the left sub-expression, false to get the right sub-expression.
  Returns:
    the sub-expression